#ifndef ATL_RESTRICT
#if defined(__STDC_VERSION__) && (__STDC_VERSION__/100 >= 1999)
   #define ATL_RESTRICT restrict
#else
   #define ATL_RESTRICT
#endif
#endif
#include "atlas_prefetch.h"

#ifndef ATL_RESTRICT
#if defined(__STDC_VERSION__) && (__STDC_VERSION__/100 >= 1999)
   #define ATL_RESTRICT restrict
#else
   #define ATL_RESTRICT
#endif
#endif
#include "atlas_prefetch.h"

static void ATL_cJIK4x40x40TN4x4x4_a1_b1
   (const int M, const int N, const int K, const float alpha, const float * ATL_RESTRICT A, const int lda, const float * ATL_RESTRICT B, const int ldb, const float beta, float * ATL_RESTRICT C, const int ldc)
/*
 * matmul with TA=T, TB=N, MB=4, NB=40, KB=40, 
 * lda=0, ldb=0, ldc=0, mu=4, nu=4, ku=4, pf=1
 * Generated by ATLAS/tune/blas/gemm/emit_mm.c (3.10.2)
 */
{
   const float *stM = A + (((lda) << 3));
   const float *stN = B + (((ldb) << 6)+((ldb) << 4));
   const float *pfA = A + M;
   #define incAk 8
   const int incAm = ((((((lda) << 2)) - 40) << 1)), incAn = -(((lda) << 3));
   #define incBk 8
   const int incBm = -80, incBn = (((ldb) << 3));
   const int incAk0 = ((incAk) >> 2), incBk0 = ((incBk) >> 2);
   #define incCm 8
   const int incCn = (((ldc) << 3)) - 8;
   float *pC0=C, *pC1=pC0+(((ldc) << 1)), *pC2=pC1+(((ldc) << 1)), *pC3=pC2+(((ldc) << 1));
   const float *pA0=A, *pA1=pA0+(((lda) << 1)), *pA2=pA1+(((lda) << 1)), *pA3=pA2+(((lda) << 1));
   const float *pB0=B, *pB1=pB0+(((ldb) << 1)), *pB2=pB1+(((ldb) << 1)), *pB3=pB2+(((ldb) << 1));
   register int k;
   register float rA0, rA1, rA2, rA3;
   register float rB0, rB1, rB2, rB3;
   register float m0, m1;
   register float rC0_0, rC1_0, rC2_0, rC3_0, rC0_1, rC1_1, rC2_1, rC3_1, rC0_2, rC1_2, rC2_2, rC3_2, rC0_3, rC1_3, rC2_3, rC3_3;
   do /* N-loop */
   {
      ATL_pfl1R(pfA+0);
      pfA += lda;
      rC0_0 = *pC0;
      rC1_0 = pC0[2];
      rC2_0 = pC0[4];
      rC3_0 = pC0[6];
      rC0_1 = *pC1;
      rC1_1 = pC1[2];
      rC2_1 = pC1[4];
      rC3_1 = pC1[6];
      rC0_2 = *pC2;
      rC1_2 = pC2[2];
      rC2_2 = pC2[4];
      rC3_2 = pC2[6];
      rC0_3 = *pC3;
      rC1_3 = pC3[2];
      rC2_3 = pC3[4];
      rC3_3 = pC3[6];
/*
 *    Start pipeline
 */
      rA0 = *pA0;
      rB0 = *pB0;
      rA1 = *pA1;
      rA2 = *pA2;
      rA3 = *pA3;
      m0 = rA0 * rB0;
      rB1 = *pB1;
      rB2 = *pB2;
      m1 = rA1 * rB0;
      rB3 = *pB3;

      for (k=36; k; k -= 4) /* easy loop to unroll */
      {
         rC0_0 += m0;
         m0 = rA2 * rB0;
         rC1_0 += m1;
         m1 = rA3 * rB0;
         rC2_0 += m0;
         m0 = rA0 * rB1;
         rC3_0 += m1;
         m1 = rA1 * rB1;
         rC0_1 += m0;
         m0 = rA2 * rB1;
         rC1_1 += m1;
         m1 = rA3 * rB1;
         rC2_1 += m0;
         m0 = rA0 * rB2;
         rC3_1 += m1;
         m1 = rA1 * rB2;
         rC0_2 += m0;
         m0 = rA2 * rB2;
         rC1_2 += m1;
         m1 = rA3 * rB2;
         rC2_2 += m0;
         m0 = rA0 * rB3;
         rC3_2 += m1;
         m1 = rA1 * rB3;
         rC0_3 += m0;
         m0 = rA2 * rB3;
         rC1_3 += m1;
         m1 = rA3 * rB3;
         rA0 = pA0[2];
         rB0 = pB0[2];
         rA1 = pA1[2];
         rA2 = pA2[2];
         rA3 = pA3[2];
         rB1 = pB1[2];
         rB2 = pB2[2];
         rC2_3 += m0;
         m0 = rA0 * rB0;
         rB3 = pB3[2];
         rC3_3 += m1;
         m1 = rA1 * rB0;
         rC0_0 += m0;
         m0 = rA2 * rB0;
         rC1_0 += m1;
         m1 = rA3 * rB0;
         rC2_0 += m0;
         m0 = rA0 * rB1;
         rC3_0 += m1;
         m1 = rA1 * rB1;
         rC0_1 += m0;
         m0 = rA2 * rB1;
         rC1_1 += m1;
         m1 = rA3 * rB1;
         rC2_1 += m0;
         m0 = rA0 * rB2;
         rC3_1 += m1;
         m1 = rA1 * rB2;
         rC0_2 += m0;
         m0 = rA2 * rB2;
         rC1_2 += m1;
         m1 = rA3 * rB2;
         rC2_2 += m0;
         m0 = rA0 * rB3;
         rC3_2 += m1;
         m1 = rA1 * rB3;
         rC0_3 += m0;
         m0 = rA2 * rB3;
         rC1_3 += m1;
         m1 = rA3 * rB3;
         rA0 = pA0[4];
         rB0 = pB0[4];
         rA1 = pA1[4];
         rA2 = pA2[4];
         rA3 = pA3[4];
         rB1 = pB1[4];
         rB2 = pB2[4];
         rC2_3 += m0;
         m0 = rA0 * rB0;
         rB3 = pB3[4];
         rC3_3 += m1;
         m1 = rA1 * rB0;
         rC0_0 += m0;
         m0 = rA2 * rB0;
         rC1_0 += m1;
         m1 = rA3 * rB0;
         rC2_0 += m0;
         m0 = rA0 * rB1;
         rC3_0 += m1;
         m1 = rA1 * rB1;
         rC0_1 += m0;
         m0 = rA2 * rB1;
         rC1_1 += m1;
         m1 = rA3 * rB1;
         rC2_1 += m0;
         m0 = rA0 * rB2;
         rC3_1 += m1;
         m1 = rA1 * rB2;
         rC0_2 += m0;
         m0 = rA2 * rB2;
         rC1_2 += m1;
         m1 = rA3 * rB2;
         rC2_2 += m0;
         m0 = rA0 * rB3;
         rC3_2 += m1;
         m1 = rA1 * rB3;
         rC0_3 += m0;
         m0 = rA2 * rB3;
         rC1_3 += m1;
         m1 = rA3 * rB3;
         rA0 = pA0[6];
         rB0 = pB0[6];
         rA1 = pA1[6];
         rA2 = pA2[6];
         rA3 = pA3[6];
         rB1 = pB1[6];
         rB2 = pB2[6];
         rC2_3 += m0;
         m0 = rA0 * rB0;
         rB3 = pB3[6];
         rC3_3 += m1;
         m1 = rA1 * rB0;
         rC0_0 += m0;
         m0 = rA2 * rB0;
         rC1_0 += m1;
         m1 = rA3 * rB0;
         rC2_0 += m0;
         m0 = rA0 * rB1;
         rC3_0 += m1;
         m1 = rA1 * rB1;
         rC0_1 += m0;
         m0 = rA2 * rB1;
         rC1_1 += m1;
         m1 = rA3 * rB1;
         rC2_1 += m0;
         m0 = rA0 * rB2;
         rC3_1 += m1;
         m1 = rA1 * rB2;
         rC0_2 += m0;
         m0 = rA2 * rB2;
         rC1_2 += m1;
         m1 = rA3 * rB2;
         rC2_2 += m0;
         m0 = rA0 * rB3;
         rC3_2 += m1;
         m1 = rA1 * rB3;
         rC0_3 += m0;
         m0 = rA2 * rB3;
         rC1_3 += m1;
         m1 = rA3 * rB3;
         rA0 = pA0[8];
         rB0 = pB0[8];
         rA1 = pA1[8];
         rA2 = pA2[8];
         rA3 = pA3[8];
         rB1 = pB1[8];
         rB2 = pB2[8];
         rC2_3 += m0;
         m0 = rA0 * rB0;
         rB3 = pB3[8];
         rC3_3 += m1;
         m1 = rA1 * rB0;
         pA0 += incAk;
         pA1 += incAk;
         pA2 += incAk;
         pA3 += incAk;
         pB0 += incBk;
         pB1 += incBk;
         pB2 += incBk;
         pB3 += incBk;
      } /* end K-loop */
      rC0_0 += m0;
      m0 = rA2 * rB0;
      rC1_0 += m1;
      m1 = rA3 * rB0;
      rC2_0 += m0;
      m0 = rA0 * rB1;
      rC3_0 += m1;
      m1 = rA1 * rB1;
      rC0_1 += m0;
      m0 = rA2 * rB1;
      rC1_1 += m1;
      m1 = rA3 * rB1;
      rC2_1 += m0;
      m0 = rA0 * rB2;
      rC3_1 += m1;
      m1 = rA1 * rB2;
      rC0_2 += m0;
      m0 = rA2 * rB2;
      rC1_2 += m1;
      m1 = rA3 * rB2;
      rC2_2 += m0;
      m0 = rA0 * rB3;
      rC3_2 += m1;
      m1 = rA1 * rB3;
      rC0_3 += m0;
      m0 = rA2 * rB3;
      rC1_3 += m1;
      m1 = rA3 * rB3;
      rA0 = pA0[2];
      rB0 = pB0[2];
      rA1 = pA1[2];
      rA2 = pA2[2];
      rA3 = pA3[2];
      rB1 = pB1[2];
      rB2 = pB2[2];
      rC2_3 += m0;
      m0 = rA0 * rB0;
      rB3 = pB3[2];
      rC3_3 += m1;
      m1 = rA1 * rB0;
      rC0_0 += m0;
      m0 = rA2 * rB0;
      rC1_0 += m1;
      m1 = rA3 * rB0;
      rC2_0 += m0;
      m0 = rA0 * rB1;
      rC3_0 += m1;
      m1 = rA1 * rB1;
      rC0_1 += m0;
      m0 = rA2 * rB1;
      rC1_1 += m1;
      m1 = rA3 * rB1;
      rC2_1 += m0;
      m0 = rA0 * rB2;
      rC3_1 += m1;
      m1 = rA1 * rB2;
      rC0_2 += m0;
      m0 = rA2 * rB2;
      rC1_2 += m1;
      m1 = rA3 * rB2;
      rC2_2 += m0;
      m0 = rA0 * rB3;
      rC3_2 += m1;
      m1 = rA1 * rB3;
      rC0_3 += m0;
      m0 = rA2 * rB3;
      rC1_3 += m1;
      m1 = rA3 * rB3;
      rA0 = pA0[4];
      rB0 = pB0[4];
      rA1 = pA1[4];
      rA2 = pA2[4];
      rA3 = pA3[4];
      rB1 = pB1[4];
      rB2 = pB2[4];
      rC2_3 += m0;
      m0 = rA0 * rB0;
      rB3 = pB3[4];
      rC3_3 += m1;
      m1 = rA1 * rB0;
      rC0_0 += m0;
      m0 = rA2 * rB0;
      rC1_0 += m1;
      m1 = rA3 * rB0;
      rC2_0 += m0;
      m0 = rA0 * rB1;
      rC3_0 += m1;
      m1 = rA1 * rB1;
      rC0_1 += m0;
      m0 = rA2 * rB1;
      rC1_1 += m1;
      m1 = rA3 * rB1;
      rC2_1 += m0;
      m0 = rA0 * rB2;
      rC3_1 += m1;
      m1 = rA1 * rB2;
      rC0_2 += m0;
      m0 = rA2 * rB2;
      rC1_2 += m1;
      m1 = rA3 * rB2;
      rC2_2 += m0;
      m0 = rA0 * rB3;
      rC3_2 += m1;
      m1 = rA1 * rB3;
      rC0_3 += m0;
      m0 = rA2 * rB3;
      rC1_3 += m1;
      m1 = rA3 * rB3;
      rA0 = pA0[6];
      rB0 = pB0[6];
      rA1 = pA1[6];
      rA2 = pA2[6];
      rA3 = pA3[6];
      rB1 = pB1[6];
      rB2 = pB2[6];
      rC2_3 += m0;
      m0 = rA0 * rB0;
      rB3 = pB3[6];
      rC3_3 += m1;
      m1 = rA1 * rB0;
      pA0 += (((incAk0) << 1)+incAk0);
      pA1 += (((incAk0) << 1)+incAk0);
      pA2 += (((incAk0) << 1)+incAk0);
      pA3 += (((incAk0) << 1)+incAk0);
      pB0 += (((incBk0) << 1)+incBk0);
      pB1 += (((incBk0) << 1)+incBk0);
      pB2 += (((incBk0) << 1)+incBk0);
      pB3 += (((incBk0) << 1)+incBk0);
/*
 *    Drain pipe on last iteration of K-loop
 */
      rC0_0 += m0;
      m0 = rA2 * rB0;
      rC1_0 += m1;
      m1 = rA3 * rB0;
      rC2_0 += m0;
      m0 = rA0 * rB1;
      rC3_0 += m1;
      m1 = rA1 * rB1;
      rC0_1 += m0;
      m0 = rA2 * rB1;
      rC1_1 += m1;
      m1 = rA3 * rB1;
      rC2_1 += m0;
      m0 = rA0 * rB2;
      rC3_1 += m1;
      m1 = rA1 * rB2;
      rC0_2 += m0;
      m0 = rA2 * rB2;
      rC1_2 += m1;
      m1 = rA3 * rB2;
      rC2_2 += m0;
      m0 = rA0 * rB3;
      rC3_2 += m1;
      m1 = rA1 * rB3;
      rC0_3 += m0;
      m0 = rA2 * rB3;
      rC1_3 += m1;
      m1 = rA3 * rB3;
      rC2_3 += m0;
      rC3_3 += m1;
      pA0 += incAk0;
      pA1 += incAk0;
      pA2 += incAk0;
      pA3 += incAk0;
      pB0 += incBk0;
      pB1 += incBk0;
      pB2 += incBk0;
      pB3 += incBk0;
      *pC0 = rC0_0;
      pC0[2] = rC1_0;
      pC0[4] = rC2_0;
      pC0[6] = rC3_0;
      *pC1 = rC0_1;
      pC1[2] = rC1_1;
      pC1[4] = rC2_1;
      pC1[6] = rC3_1;
      *pC2 = rC0_2;
      pC2[2] = rC1_2;
      pC2[4] = rC2_2;
      pC2[6] = rC3_2;
      *pC3 = rC0_3;
      pC3[2] = rC1_3;
      pC3[4] = rC2_3;
      pC3[6] = rC3_3;
      pC0 += incCm;
      pC1 += incCm;
      pC2 += incCm;
      pC3 += incCm;
      pA0 += incAm;
      pA1 += incAm;
      pA2 += incAm;
      pA3 += incAm;
      pB0 += incBm;
      pB1 += incBm;
      pB2 += incBm;
      pB3 += incBm;
      pC0 += incCn;
      pC1 += incCn;
      pC2 += incCn;
      pC3 += incCn;
      pA0 += incAn;
      pA1 += incAn;
      pA2 += incAn;
      pA3 += incAn;
      pB0 += incBn;
      pB1 += incBn;
      pB2 += incBn;
      pB3 += incBn;
   }
   while(pB0 != stN);
}
#ifdef incAm
   #undef incAm
#endif
#ifdef incAn
   #undef incAn
#endif
#ifdef incAk
   #undef incAk
#endif
#ifdef incBm
   #undef incBm
#endif
#ifdef incBn
   #undef incBn
#endif
#ifdef incBk
   #undef incBk
#endif
#ifdef incCm
   #undef incCm
#endif
#ifdef incCn
   #undef incCn
#endif
#ifdef incCk
   #undef incCk
#endif
#ifdef Mb
   #undef Mb
#endif
#ifdef Nb
   #undef Nb
#endif
#ifdef Kb
   #undef Kb
#endif
void ATL_cJIK40x40x40TN0x0x0_a1_b1
   (const int M, const int N, const int K, const float alpha, const float * ATL_RESTRICT A, const int lda, const float * ATL_RESTRICT B, const int ldb, const float beta, float * ATL_RESTRICT C, const int ldc)
/*
 * matmul with TA=T, TB=N, MB=40, NB=40, KB=40, 
 * lda=0, ldb=0, ldc=0, mu=6, nu=4, ku=4, pf=1
 * Generated by ATLAS/tune/blas/gemm/emit_mm.c (3.10.2)
 */
{
   const float *ca=A, *cb=B;
   float *cc=C;
   const float *stM = A + (((lda) << 6)+((lda) << 3));
   const float *stN = B + (((ldb) << 6)+((ldb) << 4));
   const float *pfA = A + M;
   #define incAk 8
   const int incAm = ((((((lda) << 2)+((lda) << 1)) - 40) << 1)), incAn = -(((lda) << 6)+((lda) << 3));
   #define incBk 8
   const int incBm = -80, incBn = (((ldb) << 3));
   const int incAk0 = ((incAk) >> 2), incBk0 = ((incBk) >> 2);
   #define incCm 12
   const int incCn = (((ldc) << 3)) - 72;
   float *pC0=C, *pC1=pC0+(((ldc) << 1)), *pC2=pC1+(((ldc) << 1)), *pC3=pC2+(((ldc) << 1));
   const float *pA0=A, *pA1=pA0+(((lda) << 1)), *pA2=pA1+(((lda) << 1)), *pA3=pA2+(((lda) << 1)), *pA4=pA3+(((lda) << 1)), *pA5=pA4+(((lda) << 1));
   const float *pB0=B, *pB1=pB0+(((ldb) << 1)), *pB2=pB1+(((ldb) << 1)), *pB3=pB2+(((ldb) << 1));
   register int k;
   register float rA0, rA1, rA2, rA3, rA4, rA5;
   register float rB0, rB1, rB2, rB3;
   register float m0, m1;
   register float rC0_0, rC1_0, rC2_0, rC3_0, rC4_0, rC5_0, rC0_1, rC1_1, rC2_1, rC3_1, rC4_1, rC5_1, rC0_2, rC1_2, rC2_2, rC3_2, rC4_2, rC5_2, rC0_3, rC1_3, rC2_3, rC3_3, rC4_3, rC5_3;
   do /* N-loop */
   {
      ATL_pfl1R(pfA+0);
      pfA += lda;
      do /* M-loop */
      {
         rC0_0 = *pC0;
         rC1_0 = pC0[2];
         rC2_0 = pC0[4];
         rC3_0 = pC0[6];
         rC4_0 = pC0[8];
         rC5_0 = pC0[10];
         rC0_1 = *pC1;
         rC1_1 = pC1[2];
         rC2_1 = pC1[4];
         rC3_1 = pC1[6];
         rC4_1 = pC1[8];
         rC5_1 = pC1[10];
         rC0_2 = *pC2;
         rC1_2 = pC2[2];
         rC2_2 = pC2[4];
         rC3_2 = pC2[6];
         rC4_2 = pC2[8];
         rC5_2 = pC2[10];
         rC0_3 = *pC3;
         rC1_3 = pC3[2];
         rC2_3 = pC3[4];
         rC3_3 = pC3[6];
         rC4_3 = pC3[8];
         rC5_3 = pC3[10];
/*
 *       Start pipeline
 */
         rA0 = *pA0;
         rB0 = *pB0;
         rA1 = *pA1;
         rA2 = *pA2;
         rA3 = *pA3;
         m0 = rA0 * rB0;
         rA4 = *pA4;
         rA5 = *pA5;
         m1 = rA1 * rB0;
         rB1 = *pB1;
         rB2 = *pB2;

         for (k=36; k; k -= 4) /* easy loop to unroll */
         {
            rC0_0 += m0;
            m0 = rA2 * rB0;
            rB3 = *pB3;
            rC1_0 += m1;
            m1 = rA3 * rB0;
            rC2_0 += m0;
            m0 = rA4 * rB0;
            rC3_0 += m1;
            m1 = rA5 * rB0;
            rC4_0 += m0;
            m0 = rA0 * rB1;
            rC5_0 += m1;
            m1 = rA1 * rB1;
            rC0_1 += m0;
            m0 = rA2 * rB1;
            rC1_1 += m1;
            m1 = rA3 * rB1;
            rC2_1 += m0;
            m0 = rA4 * rB1;
            rC3_1 += m1;
            m1 = rA5 * rB1;
            rC4_1 += m0;
            m0 = rA0 * rB2;
            rC5_1 += m1;
            m1 = rA1 * rB2;
            rC0_2 += m0;
            m0 = rA2 * rB2;
            rC1_2 += m1;
            m1 = rA3 * rB2;
            rC2_2 += m0;
            m0 = rA4 * rB2;
            rC3_2 += m1;
            m1 = rA5 * rB2;
            rC4_2 += m0;
            m0 = rA0 * rB3;
            rC5_2 += m1;
            m1 = rA1 * rB3;
            rC0_3 += m0;
            m0 = rA2 * rB3;
            rC1_3 += m1;
            m1 = rA3 * rB3;
            rC2_3 += m0;
            m0 = rA4 * rB3;
            rC3_3 += m1;
            m1 = rA5 * rB3;
            rA0 = pA0[2];
            rB0 = pB0[2];
            rA1 = pA1[2];
            rA2 = pA2[2];
            rA3 = pA3[2];
            rA4 = pA4[2];
            rA5 = pA5[2];
            rC4_3 += m0;
            m0 = rA0 * rB0;
            rB1 = pB1[2];
            rB2 = pB2[2];
            rC5_3 += m1;
            m1 = rA1 * rB0;
            rB3 = pB3[2];
            rC0_0 += m0;
            m0 = rA2 * rB0;
            rC1_0 += m1;
            m1 = rA3 * rB0;
            rC2_0 += m0;
            m0 = rA4 * rB0;
            rC3_0 += m1;
            m1 = rA5 * rB0;
            rC4_0 += m0;
            m0 = rA0 * rB1;
            rC5_0 += m1;
            m1 = rA1 * rB1;
            rC0_1 += m0;
            m0 = rA2 * rB1;
            rC1_1 += m1;
            m1 = rA3 * rB1;
            rC2_1 += m0;
            m0 = rA4 * rB1;
            rC3_1 += m1;
            m1 = rA5 * rB1;
            rC4_1 += m0;
            m0 = rA0 * rB2;
            rC5_1 += m1;
            m1 = rA1 * rB2;
            rC0_2 += m0;
            m0 = rA2 * rB2;
            rC1_2 += m1;
            m1 = rA3 * rB2;
            rC2_2 += m0;
            m0 = rA4 * rB2;
            rC3_2 += m1;
            m1 = rA5 * rB2;
            rC4_2 += m0;
            m0 = rA0 * rB3;
            rC5_2 += m1;
            m1 = rA1 * rB3;
            rC0_3 += m0;
            m0 = rA2 * rB3;
            rC1_3 += m1;
            m1 = rA3 * rB3;
            rC2_3 += m0;
            m0 = rA4 * rB3;
            rC3_3 += m1;
            m1 = rA5 * rB3;
            rA0 = pA0[4];
            rB0 = pB0[4];
            rA1 = pA1[4];
            rA2 = pA2[4];
            rA3 = pA3[4];
            rA4 = pA4[4];
            rA5 = pA5[4];
            rC4_3 += m0;
            m0 = rA0 * rB0;
            rB1 = pB1[4];
            rB2 = pB2[4];
            rC5_3 += m1;
            m1 = rA1 * rB0;
            rB3 = pB3[4];
            rC0_0 += m0;
            m0 = rA2 * rB0;
            rC1_0 += m1;
            m1 = rA3 * rB0;
            rC2_0 += m0;
            m0 = rA4 * rB0;
            rC3_0 += m1;
            m1 = rA5 * rB0;
            rC4_0 += m0;
            m0 = rA0 * rB1;
            rC5_0 += m1;
            m1 = rA1 * rB1;
            rC0_1 += m0;
            m0 = rA2 * rB1;
            rC1_1 += m1;
            m1 = rA3 * rB1;
            rC2_1 += m0;
            m0 = rA4 * rB1;
            rC3_1 += m1;
            m1 = rA5 * rB1;
            rC4_1 += m0;
            m0 = rA0 * rB2;
            rC5_1 += m1;
            m1 = rA1 * rB2;
            rC0_2 += m0;
            m0 = rA2 * rB2;
            rC1_2 += m1;
            m1 = rA3 * rB2;
            rC2_2 += m0;
            m0 = rA4 * rB2;
            rC3_2 += m1;
            m1 = rA5 * rB2;
            rC4_2 += m0;
            m0 = rA0 * rB3;
            rC5_2 += m1;
            m1 = rA1 * rB3;
            rC0_3 += m0;
            m0 = rA2 * rB3;
            rC1_3 += m1;
            m1 = rA3 * rB3;
            rC2_3 += m0;
            m0 = rA4 * rB3;
            rC3_3 += m1;
            m1 = rA5 * rB3;
            rA0 = pA0[6];
            rB0 = pB0[6];
            rA1 = pA1[6];
            rA2 = pA2[6];
            rA3 = pA3[6];
            rA4 = pA4[6];
            rA5 = pA5[6];
            rC4_3 += m0;
            m0 = rA0 * rB0;
            rB1 = pB1[6];
            rB2 = pB2[6];
            rC5_3 += m1;
            m1 = rA1 * rB0;
            rB3 = pB3[6];
            rC0_0 += m0;
            m0 = rA2 * rB0;
            rC1_0 += m1;
            m1 = rA3 * rB0;
            rC2_0 += m0;
            m0 = rA4 * rB0;
            rC3_0 += m1;
            m1 = rA5 * rB0;
            rC4_0 += m0;
            m0 = rA0 * rB1;
            rC5_0 += m1;
            m1 = rA1 * rB1;
            rC0_1 += m0;
            m0 = rA2 * rB1;
            rC1_1 += m1;
            m1 = rA3 * rB1;
            rC2_1 += m0;
            m0 = rA4 * rB1;
            rC3_1 += m1;
            m1 = rA5 * rB1;
            rC4_1 += m0;
            m0 = rA0 * rB2;
            rC5_1 += m1;
            m1 = rA1 * rB2;
            rC0_2 += m0;
            m0 = rA2 * rB2;
            rC1_2 += m1;
            m1 = rA3 * rB2;
            rC2_2 += m0;
            m0 = rA4 * rB2;
            rC3_2 += m1;
            m1 = rA5 * rB2;
            rC4_2 += m0;
            m0 = rA0 * rB3;
            rC5_2 += m1;
            m1 = rA1 * rB3;
            rC0_3 += m0;
            m0 = rA2 * rB3;
            rC1_3 += m1;
            m1 = rA3 * rB3;
            rC2_3 += m0;
            m0 = rA4 * rB3;
            rC3_3 += m1;
            m1 = rA5 * rB3;
            rA0 = pA0[8];
            rB0 = pB0[8];
            rA1 = pA1[8];
            rA2 = pA2[8];
            rA3 = pA3[8];
            rA4 = pA4[8];
            rA5 = pA5[8];
            rC4_3 += m0;
            m0 = rA0 * rB0;
            rB1 = pB1[8];
            rB2 = pB2[8];
            rC5_3 += m1;
            m1 = rA1 * rB0;
            rB3 = pB3[8];
            pA0 += incAk;
            pA1 += incAk;
            pA2 += incAk;
            pA3 += incAk;
            pA4 += incAk;
            pA5 += incAk;
            pB0 += incBk;
            pB1 += incBk;
            pB2 += incBk;
            pB3 += incBk;
         } /* end K-loop */
         rC0_0 += m0;
         m0 = rA2 * rB0;
         rC1_0 += m1;
         m1 = rA3 * rB0;
         rC2_0 += m0;
         m0 = rA4 * rB0;
         rC3_0 += m1;
         m1 = rA5 * rB0;
         rC4_0 += m0;
         m0 = rA0 * rB1;
         rC5_0 += m1;
         m1 = rA1 * rB1;
         rC0_1 += m0;
         m0 = rA2 * rB1;
         rC1_1 += m1;
         m1 = rA3 * rB1;
         rC2_1 += m0;
         m0 = rA4 * rB1;
         rC3_1 += m1;
         m1 = rA5 * rB1;
         rC4_1 += m0;
         m0 = rA0 * rB2;
         rC5_1 += m1;
         m1 = rA1 * rB2;
         rC0_2 += m0;
         m0 = rA2 * rB2;
         rC1_2 += m1;
         m1 = rA3 * rB2;
         rC2_2 += m0;
         m0 = rA4 * rB2;
         rC3_2 += m1;
         m1 = rA5 * rB2;
         rC4_2 += m0;
         m0 = rA0 * rB3;
         rC5_2 += m1;
         m1 = rA1 * rB3;
         rC0_3 += m0;
         m0 = rA2 * rB3;
         rC1_3 += m1;
         m1 = rA3 * rB3;
         rC2_3 += m0;
         m0 = rA4 * rB3;
         rC3_3 += m1;
         m1 = rA5 * rB3;
         rA0 = pA0[2];
         rB0 = pB0[2];
         rA1 = pA1[2];
         rA2 = pA2[2];
         rA3 = pA3[2];
         rA4 = pA4[2];
         rA5 = pA5[2];
         rC4_3 += m0;
         m0 = rA0 * rB0;
         rB1 = pB1[2];
         rB2 = pB2[2];
         rC5_3 += m1;
         m1 = rA1 * rB0;
         rB3 = pB3[2];
         rC0_0 += m0;
         m0 = rA2 * rB0;
         rC1_0 += m1;
         m1 = rA3 * rB0;
         rC2_0 += m0;
         m0 = rA4 * rB0;
         rC3_0 += m1;
         m1 = rA5 * rB0;
         rC4_0 += m0;
         m0 = rA0 * rB1;
         rC5_0 += m1;
         m1 = rA1 * rB1;
         rC0_1 += m0;
         m0 = rA2 * rB1;
         rC1_1 += m1;
         m1 = rA3 * rB1;
         rC2_1 += m0;
         m0 = rA4 * rB1;
         rC3_1 += m1;
         m1 = rA5 * rB1;
         rC4_1 += m0;
         m0 = rA0 * rB2;
         rC5_1 += m1;
         m1 = rA1 * rB2;
         rC0_2 += m0;
         m0 = rA2 * rB2;
         rC1_2 += m1;
         m1 = rA3 * rB2;
         rC2_2 += m0;
         m0 = rA4 * rB2;
         rC3_2 += m1;
         m1 = rA5 * rB2;
         rC4_2 += m0;
         m0 = rA0 * rB3;
         rC5_2 += m1;
         m1 = rA1 * rB3;
         rC0_3 += m0;
         m0 = rA2 * rB3;
         rC1_3 += m1;
         m1 = rA3 * rB3;
         rC2_3 += m0;
         m0 = rA4 * rB3;
         rC3_3 += m1;
         m1 = rA5 * rB3;
         rA0 = pA0[4];
         rB0 = pB0[4];
         rA1 = pA1[4];
         rA2 = pA2[4];
         rA3 = pA3[4];
         rA4 = pA4[4];
         rA5 = pA5[4];
         rC4_3 += m0;
         m0 = rA0 * rB0;
         rB1 = pB1[4];
         rB2 = pB2[4];
         rC5_3 += m1;
         m1 = rA1 * rB0;
         rB3 = pB3[4];
         rC0_0 += m0;
         m0 = rA2 * rB0;
         rC1_0 += m1;
         m1 = rA3 * rB0;
         rC2_0 += m0;
         m0 = rA4 * rB0;
         rC3_0 += m1;
         m1 = rA5 * rB0;
         rC4_0 += m0;
         m0 = rA0 * rB1;
         rC5_0 += m1;
         m1 = rA1 * rB1;
         rC0_1 += m0;
         m0 = rA2 * rB1;
         rC1_1 += m1;
         m1 = rA3 * rB1;
         rC2_1 += m0;
         m0 = rA4 * rB1;
         rC3_1 += m1;
         m1 = rA5 * rB1;
         rC4_1 += m0;
         m0 = rA0 * rB2;
         rC5_1 += m1;
         m1 = rA1 * rB2;
         rC0_2 += m0;
         m0 = rA2 * rB2;
         rC1_2 += m1;
         m1 = rA3 * rB2;
         rC2_2 += m0;
         m0 = rA4 * rB2;
         rC3_2 += m1;
         m1 = rA5 * rB2;
         rC4_2 += m0;
         m0 = rA0 * rB3;
         rC5_2 += m1;
         m1 = rA1 * rB3;
         rC0_3 += m0;
         m0 = rA2 * rB3;
         rC1_3 += m1;
         m1 = rA3 * rB3;
         rC2_3 += m0;
         m0 = rA4 * rB3;
         rC3_3 += m1;
         m1 = rA5 * rB3;
         rA0 = pA0[6];
         rB0 = pB0[6];
         rA1 = pA1[6];
         rA2 = pA2[6];
         rA3 = pA3[6];
         rA4 = pA4[6];
         rA5 = pA5[6];
         rC4_3 += m0;
         m0 = rA0 * rB0;
         rB1 = pB1[6];
         rB2 = pB2[6];
         rC5_3 += m1;
         m1 = rA1 * rB0;
         rB3 = pB3[6];
         pA0 += (((incAk0) << 1)+incAk0);
         pA1 += (((incAk0) << 1)+incAk0);
         pA2 += (((incAk0) << 1)+incAk0);
         pA3 += (((incAk0) << 1)+incAk0);
         pA4 += (((incAk0) << 1)+incAk0);
         pA5 += (((incAk0) << 1)+incAk0);
         pB0 += (((incBk0) << 1)+incBk0);
         pB1 += (((incBk0) << 1)+incBk0);
         pB2 += (((incBk0) << 1)+incBk0);
         pB3 += (((incBk0) << 1)+incBk0);
/*
 *       Drain pipe on last iteration of K-loop
 */
         rC0_0 += m0;
         m0 = rA2 * rB0;
         rC1_0 += m1;
         m1 = rA3 * rB0;
         rC2_0 += m0;
         m0 = rA4 * rB0;
         rC3_0 += m1;
         m1 = rA5 * rB0;
         rC4_0 += m0;
         m0 = rA0 * rB1;
         rC5_0 += m1;
         m1 = rA1 * rB1;
         rC0_1 += m0;
         m0 = rA2 * rB1;
         rC1_1 += m1;
         m1 = rA3 * rB1;
         rC2_1 += m0;
         m0 = rA4 * rB1;
         rC3_1 += m1;
         m1 = rA5 * rB1;
         rC4_1 += m0;
         m0 = rA0 * rB2;
         rC5_1 += m1;
         m1 = rA1 * rB2;
         rC0_2 += m0;
         m0 = rA2 * rB2;
         rC1_2 += m1;
         m1 = rA3 * rB2;
         rC2_2 += m0;
         m0 = rA4 * rB2;
         rC3_2 += m1;
         m1 = rA5 * rB2;
         rC4_2 += m0;
         m0 = rA0 * rB3;
         rC5_2 += m1;
         m1 = rA1 * rB3;
         rC0_3 += m0;
         m0 = rA2 * rB3;
         rC1_3 += m1;
         m1 = rA3 * rB3;
         rC2_3 += m0;
         m0 = rA4 * rB3;
         rC3_3 += m1;
         m1 = rA5 * rB3;
         rC4_3 += m0;
         rC5_3 += m1;
         pA0 += incAk0;
         pA1 += incAk0;
         pA2 += incAk0;
         pA3 += incAk0;
         pA4 += incAk0;
         pA5 += incAk0;
         pB0 += incBk0;
         pB1 += incBk0;
         pB2 += incBk0;
         pB3 += incBk0;
         *pC0 = rC0_0;
         pC0[2] = rC1_0;
         pC0[4] = rC2_0;
         pC0[6] = rC3_0;
         pC0[8] = rC4_0;
         pC0[10] = rC5_0;
         *pC1 = rC0_1;
         pC1[2] = rC1_1;
         pC1[4] = rC2_1;
         pC1[6] = rC3_1;
         pC1[8] = rC4_1;
         pC1[10] = rC5_1;
         *pC2 = rC0_2;
         pC2[2] = rC1_2;
         pC2[4] = rC2_2;
         pC2[6] = rC3_2;
         pC2[8] = rC4_2;
         pC2[10] = rC5_2;
         *pC3 = rC0_3;
         pC3[2] = rC1_3;
         pC3[4] = rC2_3;
         pC3[6] = rC3_3;
         pC3[8] = rC4_3;
         pC3[10] = rC5_3;
         pC0 += incCm;
         pC1 += incCm;
         pC2 += incCm;
         pC3 += incCm;
         pA0 += incAm;
         pA1 += incAm;
         pA2 += incAm;
         pA3 += incAm;
         pA4 += incAm;
         pA5 += incAm;
         pB0 += incBm;
         pB1 += incBm;
         pB2 += incBm;
         pB3 += incBm;
      }
      while(pA0 != stM);
      pC0 += incCn;
      pC1 += incCn;
      pC2 += incCn;
      pC3 += incCn;
      pA0 += incAn;
      pA1 += incAn;
      pA2 += incAn;
      pA3 += incAn;
      pA4 += incAn;
      pA5 += incAn;
      pB0 += incBn;
      pB1 += incBn;
      pB2 += incBn;
      pB3 += incBn;
   }
   while(pB0 != stN);
   ATL_cJIK4x40x40TN4x4x4_a1_b1(4, 40, 40, alpha, ca + (((lda) << 6)+((lda) << 3)), lda, cb, ldb, beta, cc + 72, ldc);
}
#ifdef incAm
   #undef incAm
#endif
#ifdef incAn
   #undef incAn
#endif
#ifdef incAk
   #undef incAk
#endif
#ifdef incBm
   #undef incBm
#endif
#ifdef incBn
   #undef incBn
#endif
#ifdef incBk
   #undef incBk
#endif
#ifdef incCm
   #undef incCm
#endif
#ifdef incCn
   #undef incCn
#endif
#ifdef incCk
   #undef incCk
#endif
#ifdef Mb
   #undef Mb
#endif
#ifdef Nb
   #undef Nb
#endif
#ifdef Kb
   #undef Kb
#endif
